<template>
    <main class="has-background-dark">
        <AppHeader :gameStarted="gameStarted" />

        <div v-if="gameStarted" class="is-flex is-flex-direction-column">
            <div class="row">
                <SectionHeader
                    name="Score Indicator"
                    internal="scoreIndicator"
                />
            </div>
            <div class="row">
                <DownDistanceCard />
                <GameClock />
                <PlayClock />
            </div>
            <div class="row">
                <TeamControl type="Home" />
                <TeamControl type="Away" />
            </div>
            <div class="row">
                <SectionHeader name="Lower Third" internal="lowerThird" />
            </div>
            <div class="row">
                <LowerThirdControl type="Home" />
                <LowerThirdControl type="Away" />
            </div>
            <div class="row">
                <LowerThirdText />
            </div>
            <div class="row">
                <SectionHeader name="Live Symbol" internal="liveSymbol" />
            </div>
            <div class="row">
                <SectionHeader name="Credits" internal="credits" />
            </div>
        </div>
        <div v-else-if="$fetchState.pending" class="section container">
            <h1 class="title">Loading game information...</h1>
        </div>
        <div v-else-if="errorOccurred" class="section container">
            <h1 class="title">Loading failed...</h1>
            <p>{{ errorMessage }}</p>
        </div>
        <div v-else class="section container">
            <h1 class="title">The game hasn't begun yet.</h1>

            <TeamInput template="Home" />
            <TeamInput template="Away" />

            <button class="button is-success is-large" @click="startGame">
                Start Game
            </button>
        </div>
    </main>
</template>

<script lang="ts">
import Vue from "vue";
import axios from "axios";
import state from "~/state";
import wait from "~/helpers/wait";
import syncGameState from "~/helpers/syncGameState";
import addInitialTemplates from "~/helpers/addInitialTemplates";

export default Vue.extend({
    data() {
        return {
            errorOccurred: false,
            errorMessage: "",
        };
    },
    computed: {
        gameStarted() {
            return state.gameStarted;
        }
    },
    async fetch() {
        try {
            const gameStatusRequest = await axios.get(
                `${process.env.ENDPOINT_URL}/isGamePlaying`
            );
            await wait(1000);

            const started: boolean = gameStatusRequest.data.data.isPlaying;
            if (started) {
                try {
                    await syncGameState();
                } catch (error) {
                    this.errorOccurred = true;
                    this.errorMessage = error.message;
                }
            }

            state.gameStarted = started;
        } catch (error) {
            this.errorOccurred = true;
            this.errorMessage = error;
        }
    },
    methods: {
        async startGame() {
            const check = confirm(
                "Are you sure you want to start the game?\nDouble-check the team information."
            );

            if (!check) return;

            try {
                await axios.post<IResponse>(
                    `${process.env.ENDPOINT_URL}/startGame`
                );

                await addInitialTemplates();

                state.gameStarted = true;
                alert("Started game successfully!");
            }

            catch (error) {
                alert("Unable to start the game (error in console)!");
                console.log(error);
            }
        }
    }
});
</script>

<style scoped>
.row {
    display: flex;
    margin-top: 30px;
    align-items: flex-start;
    justify-content: center;
}
</style>
